var autoplay = true;

function playlistAppend() {
    var playlist = $('#play-area');
    var next_box = document.createElement('div');
    var next_frame = document.createElement('iframe');
    next_frame.id = this.id + ' iframe';
    next_frame.width = Math.floor(playlist.width() * 0.9);
    next_frame.height = next_frame.width * (390 / 640);

    video_id = this.id.split(' ')[0];
    time = parseInt(this.id.split(' ')[1]) + 2;
    url = "https://www.youtube.com/embed/" + video_id + "?enablejsapi=1&origin=http://example.com";

    if (autoplay) {
        url += '&autoplay=1';
    } else {
        var overlay = document.createElement('div');
        var play = document.createElement('span');
        var remove = document.createElement('span');
        play.className = 'playthis';
        play.innerHTML = '&#9658;'
        play.onclick = playNow;
        remove.innerText = '-';
        remove.className = 'removethis';
        remove.onclick = removeEntry;

        overlay.appendChild(play);
        overlay.appendChild(remove);

        overlay.className = 'overlay';
        next_box.appendChild(overlay);
    }
    next_frame.src = url;
    next_box.appendChild(next_frame);
    playlist.append(next_box);
    if (autoplay) {
        console.log(time);
        currentTimeout = window.setTimeout(playNext, time);
        autoplay = false;
    }
}

function playNext () {
    $('#play-area div:first').remove();
    next_box = $('#play-area div:first');
    if (next_box.length == 0) {
        autoplay = true;
        return false;
    }
    next_box.children('div').remove();
    next_frame = next_box.children('iframe');
    src = next_frame.prop('src');
    time = parseInt(next_frame.prop('id').split(' ')[1]) + 2000;
    next_frame.prop('src', src + '&autoplay=1');
    console.log('next', time);
    currentTimeout = window.setTimeout(playNext, time);
}

function removeEntry() {
    this.parentNode.parentNode.remove();
}

function playNow() {
    var next_div = this.parentNode.parentNode;
    var play_area = document.getElementById('play-area');
    play_area.insertBefore(next_div, play_area.children[1]);
    play_area.scrollTop = 0;
    window.clearTimeout(currentTimeout);
    playNext();
}

function parseResults(data) {
    var resultsArea = $('#results');
    resultsArea.empty();
    resultsArea.scrollTop(0);
    for (result of data.d.results) {
        url = result.MediaUrl;

        rdiv = document.createElement('div');
        rdiv.classList.add('result-box');
        if (url.split('/')[2] == 'www.youtube.com') {
            rdiv.id = url.split('=').slice(-1)[0] + ' ' + result.RunTime;
            rdiv.classList.add('youtube');
        }
        rdiv.onclick = playlistAppend;

        thumbnail = document.createElement('img');
        thumbnail.src = result.Thumbnail.MediaUrl;

        link = document.createElement('a');
        link.href = url;
        link.innerText = result.Title;

        title = document.createElement('li');
        title.appendChild(link);

        var date = new Date(null);
        date.setSeconds(parseInt(result.RunTime) / 1000);
        length = document.createElement('li');
        length.innerHTML = 'Length: ' + date.toISOString().substr(11, 8);

        videoName = document.createElement('ul');
        videoName.appendChild(title);
        videoName.appendChild(length);

        rdiv.appendChild(videoName);
        rdiv.appendChild(thumbnail);
        resultsArea.append(rdiv);
    }    
}

document.getElementById('search-form').onsubmit = function searchBing() {
    baseURI = 'https://api.datamarket.azure.com/Bing/Search/v1/Video?$format=json&$top=10';
    query = $('#search-box').val();
    $('#query-result').src = baseURI + "&Query=" + query;
    $.ajax ({
        url: baseURI,
        data: {
            Query: "'" + query + "'"
        },
        password: 'g6rRIbubGdH+I882h/C5U5qNjJ58MBOJB0lrbzTvcGw=',
        username: 'g6rRIbubGdH+I882h/C5U5qNjJ58MBOJB0lrbzTvcGw='
    }).done(parseResults);
    return false;
};

